#!/usr/bin/env python2
# -*- coding: utf-8 -*-
##################################################
# GNU Radio Python Flow Graph
# Title: Dds Gnuradio
# Generated: Fri Apr 21 17:59:20 2017
##################################################

if __name__ == '__main__':
	import ctypes
	import sys
	if sys.platform.startswith('linux'):
		try:
			x11 = ctypes.cdll.LoadLibrary('libX11.so')
			x11.XInitThreads()
		except:
			print "Warning: failed to XInitThreads()"

from PyQt4 import Qt
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.qtgui import Range, RangeWidget
from optparse import OptionParser
import redpitaya_gnuradio
import sys


class dds_gnuradio(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Dds Gnuradio")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Dds Gnuradio")
		try:
			self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		except:
			pass
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)

		self.settings = Qt.QSettings("GNU Radio", "dds_gnuradio")
		self.restoreGeometry(self.settings.value("geometry").toByteArray())

		##################################################
		# Variables
		##################################################
		self.port = port = 1001
		self.offset_out1 = offset_out1 = 0
		self.f_dds = f_dds = 0
		self.addr = addr = "192.168.0.201"
		self.a_dds = a_dds = 0

		##################################################
		# Blocks
		##################################################
		self._offset_out1_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._offset_out1_win = RangeWidget(self._offset_out1_range, self.set_offset_out1, 'Offset DDS', "counter_slider", int)
		self.top_grid_layout.addWidget(self._offset_out1_win, 2, 0)
		self._f_dds_range = Range(0, 60000000, 1000, 0, 200)
		self._f_dds_win = RangeWidget(self._f_dds_range, self.set_f_dds, 'DDS frequency', "counter_slider", float)
		self.top_grid_layout.addWidget(self._f_dds_win, 0, 0)
		self._a_dds_range = Range(0, 2**13-1, 1, 0, 200)
		self._a_dds_win = RangeWidget(self._a_dds_range, self.set_a_dds, 'DDS amplitude', "counter_slider", int)
		self.top_grid_layout.addWidget(self._a_dds_win, 1, 0)
		self.nco_counter_send_conf_0 = redpitaya_gnuradio.nco_counter_send_conf(
				addr=addr,
				port=port,
				device='/dev/dds_freq',
				freq_ref=125000000,
				freq_dds=f_dds,
				acc_size=32,
				offset=0,
				pinc_sw=1,
				poff_sw=1,
		)
		  
		self.add_const_set_offset_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds_ampl',
				const=a_dds,
		)
		  
		self.add_const_set_offset_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds_offset',
				const=offset_out1,
		)
		  

	def closeEvent(self, event):
		self.settings = Qt.QSettings("GNU Radio", "dds_gnuradio")
		self.settings.setValue("geometry", self.saveGeometry())
		event.accept()

	def get_port(self):
		return self.port

	def set_port(self, port):
		self.port = port

	def get_offset_out1(self):
		return self.offset_out1

	def set_offset_out1(self, offset_out1):
		self.offset_out1 = offset_out1
		self.add_const_set_offset_0.set_const(device='/dev/dds_offset', const=self.offset_out1)

	def get_f_dds(self):
		return self.f_dds

	def set_f_dds(self, f_dds):
		self.f_dds = f_dds
		self.nco_counter_send_conf_0.set_nco(device='/dev/dds_freq', freq_ref=125000000, freq_dds=self.f_dds, acc_size=32, offset=0, pinc_sw=1, poff_sw=1)

	def get_addr(self):
		return self.addr

	def set_addr(self, addr):
		self.addr = addr

	def get_a_dds(self):
		return self.a_dds

	def set_a_dds(self, a_dds):
		self.a_dds = a_dds
		self.add_const_set_offset_0_0.set_const(device='/dev/dds_ampl', const=self.a_dds)


def main(top_block_cls=dds_gnuradio, options=None):

	from distutils.version import StrictVersion
	if StrictVersion(Qt.qVersion()) >= StrictVersion("4.5.0"):
		style = gr.prefs().get_string('qtgui', 'style', 'raster')
		Qt.QApplication.setGraphicsSystem(style)
	qapp = Qt.QApplication(sys.argv)

	tb = top_block_cls()
	tb.start()
	tb.show()

	def quitting():
		tb.stop()
		tb.wait()
	qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
	qapp.exec_()


if __name__ == '__main__':
	main()
