#!/usr/bin/env python2
# -*- coding: utf-8 -*-
##################################################
# GNU Radio Python Flow Graph
# Title: Iq Demod Only
# Generated: Fri Apr 21 11:41:10 2017
##################################################

if __name__ == '__main__':
	import ctypes
	import sys
	if sys.platform.startswith('linux'):
		try:
			x11 = ctypes.cdll.LoadLibrary('libX11.so')
			x11.XInitThreads()
		except:
			print "Warning: failed to XInitThreads()"

from PyQt4 import Qt
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.qtgui import Range, RangeWidget
from optparse import OptionParser
import redpitaya_gnuradio
import sys


class iq_demod_only(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Iq Demod Only")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Iq Demod Only")
		try:
			self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		except:
			pass
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)

		self.settings = Qt.QSettings("GNU Radio", "iq_demod_only")
		self.restoreGeometry(self.settings.value("geometry").toByteArray())

		##################################################
		# Variables
		##################################################
		self.port = port = 1001
		self.f_dds = f_dds = 0
		self.demod_f = demod_f = 0
		self.dds_offset = dds_offset = 0
		self.dds_ampl = dds_ampl = 0
		self.addr = addr = "192.168.0.201"
		self.adc1_offset = adc1_offset = 0

		##################################################
		# Blocks
		##################################################
		self._f_dds_range = Range(0, 60000000, 1000, 0, 200)
		self._f_dds_win = RangeWidget(self._f_dds_range, self.set_f_dds, 'f_dds', "counter_slider", float)
		self.top_grid_layout.addWidget(self._f_dds_win, 0, 0)
		self._demod_f_range = Range(0, 60000000, 1000, 0, 200)
		self._demod_f_win = RangeWidget(self._demod_f_range, self.set_demod_f, 'demod_f', "counter_slider", float)
		self.top_grid_layout.addWidget(self._demod_f_win, 1, 1)
		self._dds_offset_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._dds_offset_win = RangeWidget(self._dds_offset_range, self.set_dds_offset, 'dds_offset', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds_offset_win, 2, 0)
		self._dds_ampl_range = Range(0, 2**13-1, 1, 0, 200)
		self._dds_ampl_win = RangeWidget(self._dds_ampl_range, self.set_dds_ampl, 'dds_ampl', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds_ampl_win, 1, 0)
		self._adc1_offset_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._adc1_offset_win = RangeWidget(self._adc1_offset_range, self.set_adc1_offset, 'adc1_offset', "counter_slider", int)
		self.top_grid_layout.addWidget(self._adc1_offset_win, 0, 1)
		self.nco_counter_send_conf_0_0 = redpitaya_gnuradio.nco_counter_send_conf(
				addr=addr,
				port=port,
				device='/dev/demod_nco',
				freq_ref=125000000,
				freq_dds=demod_f,
				acc_size=32,
				offset=0,
				pinc_sw=1,
				poff_sw=1,
		)
		  
		self.nco_counter_send_conf_0 = redpitaya_gnuradio.nco_counter_send_conf(
				addr=addr,
				port=port,
				device='/dev/dds_nco',
				freq_ref=125000000,
				freq_dds=f_dds,
				acc_size=32,
				offset=0,
				pinc_sw=1,
				poff_sw=1,
		)
		  
		self.add_const_set_offset_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/adc1_offset',
				const=adc1_offset,
		)
		  
		self.add_const_set_offset_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds_ampl',
				const=dds_ampl,
		)
		  
		self.add_const_set_offset_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds_offset',
				const=dds_offset,
		)
		  

	def closeEvent(self, event):
		self.settings = Qt.QSettings("GNU Radio", "iq_demod_only")
		self.settings.setValue("geometry", self.saveGeometry())
		event.accept()

	def get_port(self):
		return self.port

	def set_port(self, port):
		self.port = port

	def get_f_dds(self):
		return self.f_dds

	def set_f_dds(self, f_dds):
		self.f_dds = f_dds
		self.nco_counter_send_conf_0.set_nco(device='/dev/dds_nco', freq_ref=125000000, freq_dds=self.f_dds, acc_size=32, offset=0, pinc_sw=1, poff_sw=1)

	def get_demod_f(self):
		return self.demod_f

	def set_demod_f(self, demod_f):
		self.demod_f = demod_f
		self.nco_counter_send_conf_0_0.set_nco(device='/dev/demod_nco', freq_ref=125000000, freq_dds=self.demod_f, acc_size=32, offset=0, pinc_sw=1, poff_sw=1)

	def get_dds_offset(self):
		return self.dds_offset

	def set_dds_offset(self, dds_offset):
		self.dds_offset = dds_offset
		self.add_const_set_offset_0.set_const(device='/dev/dds_offset', const=self.dds_offset)

	def get_dds_ampl(self):
		return self.dds_ampl

	def set_dds_ampl(self, dds_ampl):
		self.dds_ampl = dds_ampl
		self.add_const_set_offset_0_0.set_const(device='/dev/dds_ampl', const=self.dds_ampl)

	def get_addr(self):
		return self.addr

	def set_addr(self, addr):
		self.addr = addr

	def get_adc1_offset(self):
		return self.adc1_offset

	def set_adc1_offset(self, adc1_offset):
		self.adc1_offset = adc1_offset
		self.add_const_set_offset_0_1.set_const(device='/dev/adc1_offset', const=self.adc1_offset)


def main(top_block_cls=iq_demod_only, options=None):

	from distutils.version import StrictVersion
	if StrictVersion(Qt.qVersion()) >= StrictVersion("4.5.0"):
		style = gr.prefs().get_string('qtgui', 'style', 'raster')
		Qt.QApplication.setGraphicsSystem(style)
	qapp = Qt.QApplication(sys.argv)

	tb = top_block_cls()
	tb.start()
	tb.show()

	def quitting():
		tb.stop()
		tb.wait()
	qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
	qapp.exec_()


if __name__ == '__main__':
	main()
