#!/usr/bin/env python2
# -*- coding: utf-8 -*-
##################################################
# GNU Radio Python Flow Graph
# Title: Pid Vco Pid Only
# Generated: Wed May 17 11:20:13 2017
##################################################

if __name__ == '__main__':
	import ctypes
	import sys
	if sys.platform.startswith('linux'):
		try:
			x11 = ctypes.cdll.LoadLibrary('libX11.so')
			x11.XInitThreads()
		except:
			print "Warning: failed to XInitThreads()"

from PyQt4 import Qt
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.qtgui import Range, RangeWidget
from optparse import OptionParser
import redpitaya_gnuradio
import sys


class pid_vco_pid_only(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Pid Vco Pid Only")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Pid Vco Pid Only")
		try:
			self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		except:
			pass
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)

		self.settings = Qt.QSettings("GNU Radio", "pid_vco_pid_only")
		self.restoreGeometry(self.settings.value("geometry").toByteArray())

		##################################################
		# Variables
		##################################################
		self.port = port = 1001
		self.pid2_sign = pid2_sign = 0
		self.pid2_setpoint = pid2_setpoint = 0
		self.pid2_rst_int = pid2_rst_int = 0
		self.pid2_offset = pid2_offset = 0
		self.pid2_kp = pid2_kp = 0
		self.pid2_ki = pid2_ki = 0
		self.pid2_kd = pid2_kd = 0
		self.pid1_sign = pid1_sign = 0
		self.pid1_setpoint = pid1_setpoint = 0
		self.pid1_rst_int = pid1_rst_int = 0
		self.pid1_kp = pid1_kp = 0
		self.pid1_ki = pid1_ki = 0
		self.pid1_kd = pid1_kd = 0
		self.dds1_range = dds1_range = 0
		self.dds1_poff_sw = dds1_poff_sw = 1
		self.dds1_pinc_sw = dds1_pinc_sw = 1
		self.dds1_offset = dds1_offset = 0
		self.dds1_nco = dds1_nco = 40000000
		self.dds1_f0 = dds1_f0 = 40000000
		self.dds1_ampl = dds1_ampl = 0
		self.addr = addr = "192.168.0.201"
		self.adc1_offset = adc1_offset = 0

		##################################################
		# Blocks
		##################################################
		_pid2_sign_check_box = Qt.QCheckBox('pid2_sign')
		self._pid2_sign_choices = {True: 1, False: 0}
		self._pid2_sign_choices_inv = dict((v,k) for k,v in self._pid2_sign_choices.iteritems())
		self._pid2_sign_callback = lambda i: Qt.QMetaObject.invokeMethod(_pid2_sign_check_box, "setChecked", Qt.Q_ARG("bool", self._pid2_sign_choices_inv[i]))
		self._pid2_sign_callback(self.pid2_sign)
		_pid2_sign_check_box.stateChanged.connect(lambda i: self.set_pid2_sign(self._pid2_sign_choices[bool(i)]))
		self.top_grid_layout.addWidget(_pid2_sign_check_box, 10,1)
		self._pid2_setpoint_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._pid2_setpoint_win = RangeWidget(self._pid2_setpoint_range, self.set_pid2_setpoint, 'pid2_setpoint', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid2_setpoint_win, 9,1)
		_pid2_rst_int_push_button = Qt.QPushButton('pid2_rst_int')
		self._pid2_rst_int_choices = {'Pressed': 1, 'Released': 0}
		_pid2_rst_int_push_button.pressed.connect(lambda: self.set_pid2_rst_int(self._pid2_rst_int_choices['Pressed']))
		_pid2_rst_int_push_button.released.connect(lambda: self.set_pid2_rst_int(self._pid2_rst_int_choices['Released']))
		self.top_grid_layout.addWidget(_pid2_rst_int_push_button, 11,1)
		self._pid2_offset_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._pid2_offset_win = RangeWidget(self._pid2_offset_range, self.set_pid2_offset, 'pid2_offset', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid2_offset_win, 4,1)
		self._pid2_kp_range = Range(0, 2**13-1, 1, 0, 200)
		self._pid2_kp_win = RangeWidget(self._pid2_kp_range, self.set_pid2_kp, 'pid2_kp', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid2_kp_win, 6,1)
		self._pid2_ki_range = Range(0, 2**13-1, 1, 0, 200)
		self._pid2_ki_win = RangeWidget(self._pid2_ki_range, self.set_pid2_ki, 'pid2_ki', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid2_ki_win, 7,1)
		self._pid2_kd_range = Range(0, 2**13-1, 1, 0, 200)
		self._pid2_kd_win = RangeWidget(self._pid2_kd_range, self.set_pid2_kd, 'pid2_kd', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid2_kd_win, 8,1)
		_pid1_sign_check_box = Qt.QCheckBox('pid1_sign')
		self._pid1_sign_choices = {True: 1, False: 0}
		self._pid1_sign_choices_inv = dict((v,k) for k,v in self._pid1_sign_choices.iteritems())
		self._pid1_sign_callback = lambda i: Qt.QMetaObject.invokeMethod(_pid1_sign_check_box, "setChecked", Qt.Q_ARG("bool", self._pid1_sign_choices_inv[i]))
		self._pid1_sign_callback(self.pid1_sign)
		_pid1_sign_check_box.stateChanged.connect(lambda i: self.set_pid1_sign(self._pid1_sign_choices[bool(i)]))
		self.top_grid_layout.addWidget(_pid1_sign_check_box, 10,0)
		self._pid1_setpoint_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._pid1_setpoint_win = RangeWidget(self._pid1_setpoint_range, self.set_pid1_setpoint, 'pid1_setpoint', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid1_setpoint_win, 9,0)
		_pid1_rst_int_push_button = Qt.QPushButton('pid1_rst_int')
		self._pid1_rst_int_choices = {'Pressed': 1, 'Released': 0}
		_pid1_rst_int_push_button.pressed.connect(lambda: self.set_pid1_rst_int(self._pid1_rst_int_choices['Pressed']))
		_pid1_rst_int_push_button.released.connect(lambda: self.set_pid1_rst_int(self._pid1_rst_int_choices['Released']))
		self.top_grid_layout.addWidget(_pid1_rst_int_push_button, 11,0)
		self._pid1_kp_range = Range(0, 2**13-1, 1, 0, 200)
		self._pid1_kp_win = RangeWidget(self._pid1_kp_range, self.set_pid1_kp, 'pid1_kp', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid1_kp_win, 6,0)
		self._pid1_ki_range = Range(0, 2**13-1, 1, 0, 200)
		self._pid1_ki_win = RangeWidget(self._pid1_ki_range, self.set_pid1_ki, 'pid1_ki', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid1_ki_win, 7,0)
		self._pid1_kd_range = Range(0, 2**13-1, 1, 0, 200)
		self._pid1_kd_win = RangeWidget(self._pid1_kd_range, self.set_pid1_kd, 'pid1_kd', "counter_slider", int)
		self.top_grid_layout.addWidget(self._pid1_kd_win, 8,0)
		self._dds1_range_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._dds1_range_win = RangeWidget(self._dds1_range_range, self.set_dds1_range, 'dds1_range', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds1_range_win, 13,0)
		_dds1_poff_sw_check_box = Qt.QCheckBox('dds1_poff_sw')
		self._dds1_poff_sw_choices = {True: 1, False: 0}
		self._dds1_poff_sw_choices_inv = dict((v,k) for k,v in self._dds1_poff_sw_choices.iteritems())
		self._dds1_poff_sw_callback = lambda i: Qt.QMetaObject.invokeMethod(_dds1_poff_sw_check_box, "setChecked", Qt.Q_ARG("bool", self._dds1_poff_sw_choices_inv[i]))
		self._dds1_poff_sw_callback(self.dds1_poff_sw)
		_dds1_poff_sw_check_box.stateChanged.connect(lambda i: self.set_dds1_poff_sw(self._dds1_poff_sw_choices[bool(i)]))
		self.top_grid_layout.addWidget(_dds1_poff_sw_check_box, 2, 0)
		_dds1_pinc_sw_check_box = Qt.QCheckBox('dds1_pinc_sw')
		self._dds1_pinc_sw_choices = {True: 1, False: 0}
		self._dds1_pinc_sw_choices_inv = dict((v,k) for k,v in self._dds1_pinc_sw_choices.iteritems())
		self._dds1_pinc_sw_callback = lambda i: Qt.QMetaObject.invokeMethod(_dds1_pinc_sw_check_box, "setChecked", Qt.Q_ARG("bool", self._dds1_pinc_sw_choices_inv[i]))
		self._dds1_pinc_sw_callback(self.dds1_pinc_sw)
		_dds1_pinc_sw_check_box.stateChanged.connect(lambda i: self.set_dds1_pinc_sw(self._dds1_pinc_sw_choices[bool(i)]))
		self.top_grid_layout.addWidget(_dds1_pinc_sw_check_box, 1,0)
		self._dds1_offset_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._dds1_offset_win = RangeWidget(self._dds1_offset_range, self.set_dds1_offset, 'dds1_offset', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds1_offset_win, 4,0)
		self._dds1_nco_range = Range(0, 60000000, 1, 40000000, 200)
		self._dds1_nco_win = RangeWidget(self._dds1_nco_range, self.set_dds1_nco, 'dds1_nco', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds1_nco_win, 0,0)
		self._dds1_f0_range = Range(0, 60000000, 1, 40000000, 200)
		self._dds1_f0_win = RangeWidget(self._dds1_f0_range, self.set_dds1_f0, 'dds1_f0', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds1_f0_win, 12,0)
		self._dds1_ampl_range = Range(0, 2**13-1, 1, 0, 200)
		self._dds1_ampl_win = RangeWidget(self._dds1_ampl_range, self.set_dds1_ampl, 'dds1_ampl', "counter_slider", int)
		self.top_grid_layout.addWidget(self._dds1_ampl_win, 3,0)
		self._adc1_offset_range = Range(-2**13, 2**13-1, 1, 0, 200)
		self._adc1_offset_win = RangeWidget(self._adc1_offset_range, self.set_adc1_offset, 'adc1_offset', "counter_slider", int)
		self.top_grid_layout.addWidget(self._adc1_offset_win, 5,0)
		self.nco_counter_send_conf_0 = redpitaya_gnuradio.nco_counter_send_conf(
				addr=addr,
				port=port,
				device='/dev/dds1_nco',
				freq_ref=125000000,
				freq_dds=dds1_nco,
				acc_size=32,
				offset=0,
				pinc_sw=dds1_pinc_sw,
				poff_sw=dds1_poff_sw,
		)
		  
		self.add_const_set_offset_0_0_0_1_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_setpoint',
				const=pid2_setpoint,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_kp',
				const=pid2_kp,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_ki',
				const=pid2_ki,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_kd',
				const=pid2_kd,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_0_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_sign',
				const=pid2_sign,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_0_0_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_rst_int',
				const=pid2_rst_int,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_0_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid1_rst_int',
				const=pid1_rst_int,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid1_sign',
				const=pid1_sign,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid1_kd',
				const=pid1_kd,
		)
		  
		self.add_const_set_offset_0_0_0_1_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid1_ki',
				const=pid1_ki,
		)
		  
		self.add_const_set_offset_0_0_0_1_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid1_kp',
				const=pid1_kp,
		)
		  
		self.add_const_set_offset_0_0_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid1_setpoint',
				const=pid1_setpoint,
		)
		  
		self.add_const_set_offset_0_0_0_0_1_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/pid2_offset',
				const=pid2_offset,
		)
		  
		self.add_const_set_offset_0_0_0_0_1_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds1_range',
				const=dds1_range,
		)
		  
		self.add_const_set_offset_0_0_0_0_1_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds1_f0',
				const=int(dds1_f0/(125e6/2**32)),
		)
		  
		self.add_const_set_offset_0_0_0_0_1 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds1_offset',
				const=dds1_offset,
		)
		  
		self.add_const_set_offset_0_0_0_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/dds1_ampl',
				const=dds1_ampl,
		)
		  
		self.add_const_set_offset_0_0_0 = redpitaya_gnuradio.add_const_set_offset(
				addr=addr,
				port=port,
				device='/dev/adc1_offset',
				const=adc1_offset,
		)
		  

	def closeEvent(self, event):
		self.settings = Qt.QSettings("GNU Radio", "pid_vco_pid_only")
		self.settings.setValue("geometry", self.saveGeometry())
		event.accept()

	def get_port(self):
		return self.port

	def set_port(self, port):
		self.port = port

	def get_pid2_sign(self):
		return self.pid2_sign

	def set_pid2_sign(self, pid2_sign):
		self.pid2_sign = pid2_sign
		self._pid2_sign_callback(self.pid2_sign)
		self.add_const_set_offset_0_0_0_1_0_0_0_0_1.set_const(device='/dev/pid2_sign', const=self.pid2_sign)

	def get_pid2_setpoint(self):
		return self.pid2_setpoint

	def set_pid2_setpoint(self, pid2_setpoint):
		self.pid2_setpoint = pid2_setpoint
		self.add_const_set_offset_0_0_0_1_1.set_const(device='/dev/pid2_setpoint', const=self.pid2_setpoint)

	def get_pid2_rst_int(self):
		return self.pid2_rst_int

	def set_pid2_rst_int(self, pid2_rst_int):
		self.pid2_rst_int = pid2_rst_int
		self.add_const_set_offset_0_0_0_1_0_0_0_0_0_0.set_const(device='/dev/pid2_rst_int', const=self.pid2_rst_int)

	def get_pid2_offset(self):
		return self.pid2_offset

	def set_pid2_offset(self, pid2_offset):
		self.pid2_offset = pid2_offset
		self.add_const_set_offset_0_0_0_0_1_1.set_const(device='/dev/pid2_offset', const=self.pid2_offset)

	def get_pid2_kp(self):
		return self.pid2_kp

	def set_pid2_kp(self, pid2_kp):
		self.pid2_kp = pid2_kp
		self.add_const_set_offset_0_0_0_1_0_1.set_const(device='/dev/pid2_kp', const=self.pid2_kp)

	def get_pid2_ki(self):
		return self.pid2_ki

	def set_pid2_ki(self, pid2_ki):
		self.pid2_ki = pid2_ki
		self.add_const_set_offset_0_0_0_1_0_0_1.set_const(device='/dev/pid2_ki', const=self.pid2_ki)

	def get_pid2_kd(self):
		return self.pid2_kd

	def set_pid2_kd(self, pid2_kd):
		self.pid2_kd = pid2_kd
		self.add_const_set_offset_0_0_0_1_0_0_0_1.set_const(device='/dev/pid2_kd', const=self.pid2_kd)

	def get_pid1_sign(self):
		return self.pid1_sign

	def set_pid1_sign(self, pid1_sign):
		self.pid1_sign = pid1_sign
		self._pid1_sign_callback(self.pid1_sign)
		self.add_const_set_offset_0_0_0_1_0_0_0_0.set_const(device='/dev/pid1_sign', const=self.pid1_sign)

	def get_pid1_setpoint(self):
		return self.pid1_setpoint

	def set_pid1_setpoint(self, pid1_setpoint):
		self.pid1_setpoint = pid1_setpoint
		self.add_const_set_offset_0_0_0_1.set_const(device='/dev/pid1_setpoint', const=self.pid1_setpoint)

	def get_pid1_rst_int(self):
		return self.pid1_rst_int

	def set_pid1_rst_int(self, pid1_rst_int):
		self.pid1_rst_int = pid1_rst_int
		self.add_const_set_offset_0_0_0_1_0_0_0_0_0.set_const(device='/dev/pid1_rst_int', const=self.pid1_rst_int)

	def get_pid1_kp(self):
		return self.pid1_kp

	def set_pid1_kp(self, pid1_kp):
		self.pid1_kp = pid1_kp
		self.add_const_set_offset_0_0_0_1_0.set_const(device='/dev/pid1_kp', const=self.pid1_kp)

	def get_pid1_ki(self):
		return self.pid1_ki

	def set_pid1_ki(self, pid1_ki):
		self.pid1_ki = pid1_ki
		self.add_const_set_offset_0_0_0_1_0_0.set_const(device='/dev/pid1_ki', const=self.pid1_ki)

	def get_pid1_kd(self):
		return self.pid1_kd

	def set_pid1_kd(self, pid1_kd):
		self.pid1_kd = pid1_kd
		self.add_const_set_offset_0_0_0_1_0_0_0.set_const(device='/dev/pid1_kd', const=self.pid1_kd)

	def get_dds1_range(self):
		return self.dds1_range

	def set_dds1_range(self, dds1_range):
		self.dds1_range = dds1_range
		self.add_const_set_offset_0_0_0_0_1_0_0.set_const(device='/dev/dds1_range', const=self.dds1_range)

	def get_dds1_poff_sw(self):
		return self.dds1_poff_sw

	def set_dds1_poff_sw(self, dds1_poff_sw):
		self.dds1_poff_sw = dds1_poff_sw
		self._dds1_poff_sw_callback(self.dds1_poff_sw)
		self.nco_counter_send_conf_0.set_nco(device='/dev/dds1_nco', freq_ref=125000000, freq_dds=self.dds1_nco, acc_size=32, offset=0, pinc_sw=self.dds1_pinc_sw, poff_sw=self.dds1_poff_sw)

	def get_dds1_pinc_sw(self):
		return self.dds1_pinc_sw

	def set_dds1_pinc_sw(self, dds1_pinc_sw):
		self.dds1_pinc_sw = dds1_pinc_sw
		self._dds1_pinc_sw_callback(self.dds1_pinc_sw)
		self.nco_counter_send_conf_0.set_nco(device='/dev/dds1_nco', freq_ref=125000000, freq_dds=self.dds1_nco, acc_size=32, offset=0, pinc_sw=self.dds1_pinc_sw, poff_sw=self.dds1_poff_sw)

	def get_dds1_offset(self):
		return self.dds1_offset

	def set_dds1_offset(self, dds1_offset):
		self.dds1_offset = dds1_offset
		self.add_const_set_offset_0_0_0_0_1.set_const(device='/dev/dds1_offset', const=self.dds1_offset)

	def get_dds1_nco(self):
		return self.dds1_nco

	def set_dds1_nco(self, dds1_nco):
		self.dds1_nco = dds1_nco
		self.nco_counter_send_conf_0.set_nco(device='/dev/dds1_nco', freq_ref=125000000, freq_dds=self.dds1_nco, acc_size=32, offset=0, pinc_sw=self.dds1_pinc_sw, poff_sw=self.dds1_poff_sw)

	def get_dds1_f0(self):
		return self.dds1_f0

	def set_dds1_f0(self, dds1_f0):
		self.dds1_f0 = dds1_f0
		self.add_const_set_offset_0_0_0_0_1_0.set_const(device='/dev/dds1_f0', const=int(self.dds1_f0/(125e6/2**32)))

	def get_dds1_ampl(self):
		return self.dds1_ampl

	def set_dds1_ampl(self, dds1_ampl):
		self.dds1_ampl = dds1_ampl
		self.add_const_set_offset_0_0_0_0_0.set_const(device='/dev/dds1_ampl', const=self.dds1_ampl)

	def get_addr(self):
		return self.addr

	def set_addr(self, addr):
		self.addr = addr

	def get_adc1_offset(self):
		return self.adc1_offset

	def set_adc1_offset(self, adc1_offset):
		self.adc1_offset = adc1_offset
		self.add_const_set_offset_0_0_0.set_const(device='/dev/adc1_offset', const=self.adc1_offset)


def main(top_block_cls=pid_vco_pid_only, options=None):

	from distutils.version import StrictVersion
	if StrictVersion(Qt.qVersion()) >= StrictVersion("4.5.0"):
		style = gr.prefs().get_string('qtgui', 'style', 'raster')
		Qt.QApplication.setGraphicsSystem(style)
	qapp = Qt.QApplication(sys.argv)

	tb = top_block_cls()
	tb.start()
	tb.show()

	def quitting():
		tb.stop()
		tb.wait()
	qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
	qapp.exec_()


if __name__ == '__main__':
	main()
