#!/usr/bin/env python
import ctypes, argparse
import liboscimp_fpga

def parse():
	parser = argparse.ArgumentParser(description = 'Set offsets to DAC1 and DAC2')
	parser.add_argument('-of1',
						action='store',
						dest='of1',
						default=0,
						help='DAC1 offset (bits)')
	parser.add_argument('-of2',
						action='store',
						dest='of2',
						default=0,
						help='DAC2 offset (bits)')
	args = parser.parse_args()
	return args

def main():
	args = parse()
	of1 = int(args.of1)
	of2 = int(args.of2)
	liboscimp_fpga.add_const_set_offset("/dev/add_const_0", of1)
	liboscimp_fpga.add_const_set_offset("/dev/add_const_1", of2)
	print('offset DAC1 : %i'%of1)
	print('offset DAC2 : %i'%of2)

if __name__ == "__main__":
	main()
