#!/usr/bin/env python2
# -*- coding: utf-8 -*-
##################################################
# GNU Radio Python Flow Graph
# Title: Fm Radio Comp Decim Lpf
# Generated: Sat Mar 18 11:55:19 2017
##################################################

if __name__ == '__main__':
	import ctypes
	import sys
	if sys.platform.startswith('linux'):
		try:
			x11 = ctypes.cdll.LoadLibrary('libX11.so')
			x11.XInitThreads()
		except:
			print "Warning: failed to XInitThreads()"

from PyQt4 import Qt
from gnuradio import analog
from gnuradio import audio
from gnuradio import eng_notation
from gnuradio import filter
from gnuradio import gr
from gnuradio import qtgui
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.qtgui import Range, RangeWidget
from optparse import OptionParser
import osmosdr
import sip
import sys
import time


class fm_radio_comp_decim_lpf(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Fm Radio Comp Decim Lpf")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Fm Radio Comp Decim Lpf")
		try:
			self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		except:
			pass
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)

		self.settings = Qt.QSettings("GNU Radio", "fm_radio_comp_decim_lpf")
		self.restoreGeometry(self.settings.value("geometry").toByteArray())

		##################################################
		# Variables
		##################################################
		self.samp_rate = samp_rate = 48e3
		self.freq = freq = 91e6

		##################################################
		# Blocks
		##################################################
		self._freq_range = Range(1e6, 2e9, 1e5, 91e6, 200)
		self._freq_win = RangeWidget(self._freq_range, self.set_freq, "freq", "counter_slider", float)
		self.top_grid_layout.addWidget(self._freq_win, 0,0)
		self.rtlsdr_source_0 = osmosdr.source( args="numchan=" + str(1) + " " + '' )
		self.rtlsdr_source_0.set_sample_rate(samp_rate*10*4)
		self.rtlsdr_source_0.set_center_freq(freq, 0)
		self.rtlsdr_source_0.set_freq_corr(0, 0)
		self.rtlsdr_source_0.set_dc_offset_mode(0, 0)
		self.rtlsdr_source_0.set_iq_balance_mode(0, 0)
		self.rtlsdr_source_0.set_gain_mode(False, 0)
		self.rtlsdr_source_0.set_gain(30, 0)
		self.rtlsdr_source_0.set_if_gain(30, 0)
		self.rtlsdr_source_0.set_bb_gain(30, 0)
		self.rtlsdr_source_0.set_antenna('', 0)
		self.rtlsdr_source_0.set_bandwidth(0, 0)
		  
		self.rational_resampler_xxx_0_0 = filter.rational_resampler_ccc(
				interpolation=1,
				decimation=4,
				taps=(1, ),
				fractional_bw=None,
		)
		self.rational_resampler_xxx_0 = filter.rational_resampler_fff(
				interpolation=1,
				decimation=10,
				taps=(1, ),
				fractional_bw=None,
		)
		self.qtgui_freq_sink_x_0_0 = qtgui.freq_sink_f(
			1024, #size
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate*10, #bw
			"", #name
			2 #number of inputs
		)
		self.qtgui_freq_sink_x_0_0.set_update_time(0.10)
		self.qtgui_freq_sink_x_0_0.set_y_axis(-140, 10)
		self.qtgui_freq_sink_x_0_0.set_y_label('Relative Gain', 'dB')
		self.qtgui_freq_sink_x_0_0.set_trigger_mode(qtgui.TRIG_MODE_FREE, 0.0, 0, "")
		self.qtgui_freq_sink_x_0_0.enable_autoscale(False)
		self.qtgui_freq_sink_x_0_0.enable_grid(True)
		self.qtgui_freq_sink_x_0_0.set_fft_average(0.05)
		self.qtgui_freq_sink_x_0_0.enable_axis_labels(True)
		self.qtgui_freq_sink_x_0_0.enable_control_panel(False)
		
		if not True:
		  self.qtgui_freq_sink_x_0_0.disable_legend()
		
		if "float" == "float" or "float" == "msg_float":
		  self.qtgui_freq_sink_x_0_0.set_plot_pos_half(not True)
		
		labels = ['', '', '', '', '',
				  '', '', '', '', '']
		widths = [1, 1, 1, 1, 1,
				  1, 1, 1, 1, 1]
		colors = ["blue", "red", "green", "black", "cyan",
				  "magenta", "yellow", "dark red", "dark green", "dark blue"]
		alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
				  1.0, 1.0, 1.0, 1.0, 1.0]
		for i in xrange(2):
			if len(labels[i]) == 0:
				self.qtgui_freq_sink_x_0_0.set_line_label(i, "Data {0}".format(i))
			else:
				self.qtgui_freq_sink_x_0_0.set_line_label(i, labels[i])
			self.qtgui_freq_sink_x_0_0.set_line_width(i, widths[i])
			self.qtgui_freq_sink_x_0_0.set_line_color(i, colors[i])
			self.qtgui_freq_sink_x_0_0.set_line_alpha(i, alphas[i])
		
		self._qtgui_freq_sink_x_0_0_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_win, 12,0)
		self.qtgui_freq_sink_x_0 = qtgui.freq_sink_f(
			1024, #size
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"", #name
			2 #number of inputs
		)
		self.qtgui_freq_sink_x_0.set_update_time(0.10)
		self.qtgui_freq_sink_x_0.set_y_axis(-140, 10)
		self.qtgui_freq_sink_x_0.set_y_label('Relative Gain', 'dB')
		self.qtgui_freq_sink_x_0.set_trigger_mode(qtgui.TRIG_MODE_FREE, 0.0, 0, "")
		self.qtgui_freq_sink_x_0.enable_autoscale(False)
		self.qtgui_freq_sink_x_0.enable_grid(True)
		self.qtgui_freq_sink_x_0.set_fft_average(1.0)
		self.qtgui_freq_sink_x_0.enable_axis_labels(True)
		self.qtgui_freq_sink_x_0.enable_control_panel(False)
		
		if not True:
		  self.qtgui_freq_sink_x_0.disable_legend()
		
		if "float" == "float" or "float" == "msg_float":
		  self.qtgui_freq_sink_x_0.set_plot_pos_half(not True)
		
		labels = ['', '', '', '', '',
				  '', '', '', '', '']
		widths = [1, 1, 1, 1, 1,
				  1, 1, 1, 1, 1]
		colors = ["blue", "red", "green", "black", "cyan",
				  "magenta", "yellow", "dark red", "dark green", "dark blue"]
		alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
				  1.0, 1.0, 1.0, 1.0, 1.0]
		for i in xrange(2):
			if len(labels[i]) == 0:
				self.qtgui_freq_sink_x_0.set_line_label(i, "Data {0}".format(i))
			else:
				self.qtgui_freq_sink_x_0.set_line_label(i, labels[i])
			self.qtgui_freq_sink_x_0.set_line_width(i, widths[i])
			self.qtgui_freq_sink_x_0.set_line_color(i, colors[i])
			self.qtgui_freq_sink_x_0.set_line_alpha(i, alphas[i])
		
		self._qtgui_freq_sink_x_0_win = sip.wrapinstance(self.qtgui_freq_sink_x_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_win, 13,0)
		self.low_pass_filter_0_0 = filter.fir_filter_fff(10, firdes.low_pass(
			1, samp_rate*10, samp_rate, 1e3, firdes.WIN_HAMMING, 6.76))
		self.low_pass_filter_0 = filter.fir_filter_ccf(4, firdes.low_pass(
			1, samp_rate*10*4, samp_rate*10/4, 1e3, firdes.WIN_HAMMING, 6.76))
		self.audio_sink_0 = audio.sink(int(samp_rate), '', True)
		self.analog_wfm_rcv_0_0 = analog.wfm_rcv(
			quad_rate=samp_rate*10,
			audio_decimation=1,
		)
		self.analog_wfm_rcv_0 = analog.wfm_rcv(
			quad_rate=samp_rate*10,
			audio_decimation=1,
		)

		##################################################
		# Connections
		##################################################
		self.connect((self.analog_wfm_rcv_0, 0), (self.qtgui_freq_sink_x_0_0, 0))	
		self.connect((self.analog_wfm_rcv_0, 0), (self.rational_resampler_xxx_0, 0))	
		self.connect((self.analog_wfm_rcv_0_0, 0), (self.low_pass_filter_0_0, 0))	
		self.connect((self.analog_wfm_rcv_0_0, 0), (self.qtgui_freq_sink_x_0_0, 1))	
		self.connect((self.low_pass_filter_0, 0), (self.analog_wfm_rcv_0_0, 0))	
		self.connect((self.low_pass_filter_0_0, 0), (self.audio_sink_0, 0))	
		self.connect((self.low_pass_filter_0_0, 0), (self.qtgui_freq_sink_x_0, 1))	
		self.connect((self.rational_resampler_xxx_0, 0), (self.qtgui_freq_sink_x_0, 0))	
		self.connect((self.rational_resampler_xxx_0_0, 0), (self.analog_wfm_rcv_0, 0))	
		self.connect((self.rtlsdr_source_0, 0), (self.low_pass_filter_0, 0))	
		self.connect((self.rtlsdr_source_0, 0), (self.rational_resampler_xxx_0_0, 0))	

	def closeEvent(self, event):
		self.settings = Qt.QSettings("GNU Radio", "fm_radio_comp_decim_lpf")
		self.settings.setValue("geometry", self.saveGeometry())
		event.accept()

	def get_samp_rate(self):
		return self.samp_rate

	def set_samp_rate(self, samp_rate):
		self.samp_rate = samp_rate
		self.rtlsdr_source_0.set_sample_rate(self.samp_rate*10*4)
		self.qtgui_freq_sink_x_0_0.set_frequency_range(0, self.samp_rate*10)
		self.qtgui_freq_sink_x_0.set_frequency_range(0, self.samp_rate)
		self.low_pass_filter_0_0.set_taps(firdes.low_pass(1, self.samp_rate*10, self.samp_rate, 1e3, firdes.WIN_HAMMING, 6.76))
		self.low_pass_filter_0.set_taps(firdes.low_pass(1, self.samp_rate*10*4, self.samp_rate*10/4, 1e3, firdes.WIN_HAMMING, 6.76))

	def get_freq(self):
		return self.freq

	def set_freq(self, freq):
		self.freq = freq
		self.rtlsdr_source_0.set_center_freq(self.freq, 0)


def main(top_block_cls=fm_radio_comp_decim_lpf, options=None):

	from distutils.version import StrictVersion
	if StrictVersion(Qt.qVersion()) >= StrictVersion("4.5.0"):
		style = gr.prefs().get_string('qtgui', 'style', 'raster')
		Qt.QApplication.setGraphicsSystem(style)
	qapp = Qt.QApplication(sys.argv)

	tb = top_block_cls()
	tb.start()
	tb.show()

	def quitting():
		tb.stop()
		tb.wait()
	qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
	qapp.exec_()


if __name__ == '__main__':
	main()
