#!/usr/bin/env python2
# -*- coding: utf-8 -*-
##################################################
# GNU Radio Python Flow Graph
# Title: Top Block
# Generated: Mon Jul  2 09:37:35 2018
##################################################

from distutils.version import StrictVersion

if __name__ == '__main__':
    import ctypes
    import sys
    if sys.platform.startswith('linux'):
        try:
            x11 = ctypes.cdll.LoadLibrary('libX11.so')
            x11.XInitThreads()
        except:
            print "Warning: failed to XInitThreads()"

from PyQt5 import Qt
from PyQt5 import Qt, QtCore
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import qtgui
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.qtgui import Range, RangeWidget
from optparse import OptionParser
import osmosdr
import sip
import sys
import time
from gnuradio import qtgui


class top_block(gr.top_block, Qt.QWidget):

    def __init__(self):
        gr.top_block.__init__(self, "Top Block")
        Qt.QWidget.__init__(self)
        self.setWindowTitle("Top Block")
        qtgui.util.check_set_qss()
        try:
            self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
        except:
            pass
        self.top_scroll_layout = Qt.QVBoxLayout()
        self.setLayout(self.top_scroll_layout)
        self.top_scroll = Qt.QScrollArea()
        self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
        self.top_scroll_layout.addWidget(self.top_scroll)
        self.top_scroll.setWidgetResizable(True)
        self.top_widget = Qt.QWidget()
        self.top_scroll.setWidget(self.top_widget)
        self.top_layout = Qt.QVBoxLayout(self.top_widget)
        self.top_grid_layout = Qt.QGridLayout()
        self.top_layout.addLayout(self.top_grid_layout)

        self.settings = Qt.QSettings("GNU Radio", "top_block")
        self.restoreGeometry(self.settings.value("geometry", type=QtCore.QByteArray))


        ##################################################
        # Variables
        ##################################################
        self.samp_rate = samp_rate = 2e6
        self.f0 = f0 = 50e6
        self.G_RF = G_RF = 10
        self.G_IF = G_IF = 10
        self.G_BB = G_BB = 10

        ##################################################
        # Blocks
        ##################################################
        self._f0_range = Range(50e6, 2e9, 1000000, 50e6, 200)
        self._f0_win = RangeWidget(self._f0_range, self.set_f0, 'f0', "counter_slider", float)
        self.top_grid_layout.addWidget(self._f0_win)
        self._G_RF_range = Range(0, 40, 1, 10, 200)
        self._G_RF_win = RangeWidget(self._G_RF_range, self.set_G_RF, "G_RF", "counter_slider", float)
        self.top_grid_layout.addWidget(self._G_RF_win)
        self._G_IF_range = Range(0, 40, 1, 10, 200)
        self._G_IF_win = RangeWidget(self._G_IF_range, self.set_G_IF, "G_IF", "counter_slider", float)
        self.top_grid_layout.addWidget(self._G_IF_win)
        self._G_BB_range = Range(0, 40, 1, 10, 200)
        self._G_BB_win = RangeWidget(self._G_BB_range, self.set_G_BB, "G_BB", "counter_slider", float)
        self.top_grid_layout.addWidget(self._G_BB_win)
        self.rtlsdr_source_0 = osmosdr.source( args="numchan=" + str(1) + " " + '' )
        self.rtlsdr_source_0.set_sample_rate(samp_rate)
        self.rtlsdr_source_0.set_center_freq(f0, 0)
        self.rtlsdr_source_0.set_freq_corr(0, 0)
        self.rtlsdr_source_0.set_dc_offset_mode(0, 0)
        self.rtlsdr_source_0.set_iq_balance_mode(0, 0)
        self.rtlsdr_source_0.set_gain_mode(False, 0)
        self.rtlsdr_source_0.set_gain(G_RF, 0)
        self.rtlsdr_source_0.set_if_gain(G_IF, 0)
        self.rtlsdr_source_0.set_bb_gain(G_BB, 0)
        self.rtlsdr_source_0.set_antenna('', 0)
        self.rtlsdr_source_0.set_bandwidth(0, 0)

        self.qtgui_sink_x_0 = qtgui.sink_c(
        	1024, #fftsize
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"", #name
        	True, #plotfreq
        	True, #plotwaterfall
        	True, #plottime
        	True, #plotconst
        )
        self.qtgui_sink_x_0.set_update_time(1.0/10)
        self._qtgui_sink_x_0_win = sip.wrapinstance(self.qtgui_sink_x_0.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_sink_x_0_win)

        self.qtgui_sink_x_0.enable_rf_freq(False)






        ##################################################
        # Connections
        ##################################################
        self.connect((self.rtlsdr_source_0, 0), (self.qtgui_sink_x_0, 0))

    def closeEvent(self, event):
        self.settings = Qt.QSettings("GNU Radio", "top_block")
        self.settings.setValue("geometry", self.saveGeometry())
        event.accept()

    def get_samp_rate(self):
        return self.samp_rate

    def set_samp_rate(self, samp_rate):
        self.samp_rate = samp_rate
        self.rtlsdr_source_0.set_sample_rate(self.samp_rate)
        self.qtgui_sink_x_0.set_frequency_range(0, self.samp_rate)

    def get_f0(self):
        return self.f0

    def set_f0(self, f0):
        self.f0 = f0
        self.rtlsdr_source_0.set_center_freq(self.f0, 0)

    def get_G_RF(self):
        return self.G_RF

    def set_G_RF(self, G_RF):
        self.G_RF = G_RF
        self.rtlsdr_source_0.set_gain(self.G_RF, 0)

    def get_G_IF(self):
        return self.G_IF

    def set_G_IF(self, G_IF):
        self.G_IF = G_IF
        self.rtlsdr_source_0.set_if_gain(self.G_IF, 0)

    def get_G_BB(self):
        return self.G_BB

    def set_G_BB(self, G_BB):
        self.G_BB = G_BB
        self.rtlsdr_source_0.set_bb_gain(self.G_BB, 0)


def main(top_block_cls=top_block, options=None):

    qapp = Qt.QApplication(sys.argv)

    tb = top_block_cls()
    tb.start()
    tb.show()

    def quitting():
        tb.stop()
        tb.wait()
    qapp.aboutToQuit.connect(quitting)
    qapp.exec_()


if __name__ == '__main__':
    main()
